Index: doc/user-guide/Usage.xml
===================================================================
--- doc/user-guide/Usage.xml	(revision c572dd67167c0365a5bf62899c31efd4f223acaa)
+++ doc/user-guide/Usage.xml	(revision 689a6e0b8f91eecfc3add9dae769bfcda5a35b77)
@@ -14,15 +14,26 @@
 
 <sect1>
-<title>The #bitlbee control channel</title>
+<title>The &amp;bitlbee control channel</title>
 
 <para>
 Once you are connected to the BitlBee server, you are automatically joined
-to #bitlbee on that server. This channel acts like the 'buddy list' you have
+to &amp;bitlbee on that server. This channel acts like the 'buddy list' you have
 on the various other chat networks.
 </para>
 
 <para>
-The user 'root' always hangs around in #bitlbee and acts as your interface 
-to bitlbee. All commands you give on #bitlbee are 'answered' by root.
+The user 'root' always hangs around in &amp;bitlbee and acts as your interface 
+to bitlbee. All commands you give on &amp;bitlbee are 'answered' by root.
+</para>
+
+<para>
+You might be slightly confused by the &amp; in the channel name. This is,
+however, completely allowed by the IRC standards. Just try it on a regular
+IRC server, it should work. The difference between the standard #channels
+and &amp;channels is that the #channels are distributed over all the servers
+on the IRC network, while &amp;channels are local to one server. Because
+the BitlBee control channel is local to one server (and in fact, to one person),
+this name seems more suitable. Also, with this name, it's harder to confuse
+the control channel with the #bitlbee channel on OFTC.
 </para>
 
Index: doc/user-guide/commands.xml
===================================================================
--- doc/user-guide/commands.xml	(revision c572dd67167c0365a5bf62899c31efd4f223acaa)
+++ doc/user-guide/commands.xml	(revision 689a6e0b8f91eecfc3add9dae769bfcda5a35b77)
@@ -154,5 +154,5 @@
 		<ircexample>
 			<ircline nick="ctrlsoft">add 3 gryp@jabber.org grijp</ircline>
-			<ircaction nick="grijp" hostmask="gryp@jabber.org">has joined <emphasis>#bitlbee</emphasis></ircaction>
+			<ircaction nick="grijp" hostmask="gryp@jabber.org">has joined <emphasis>&amp;bitlbee</emphasis></ircaction>
 		</ircexample>
 	</bitlbee-command>
@@ -357,5 +357,5 @@
 		<description>
 			<para>
-				Some people prefer themself and root to have operator status in #bitlbee, other people don't. You can change these states using this setting.
+				Some people prefer themself and root to have operator status in &amp;bitlbee, other people don't. You can change these states using this setting.
 			</para>
 
Index: doc/user-guide/quickstart.xml
===================================================================
--- doc/user-guide/quickstart.xml	(revision c572dd67167c0365a5bf62899c31efd4f223acaa)
+++ doc/user-guide/quickstart.xml	(revision 689a6e0b8f91eecfc3add9dae769bfcda5a35b77)
@@ -7,5 +7,5 @@
 
 <para>
-The center of BitlBee is the control channel, <emphasis>#bitlbee</emphasis>. Two users will always be there, <emphasis>you</emphasis> (where "you" is the nickname you are using) and the system user, <emphasis>root</emphasis>.
+The center of BitlBee is the control channel, <emphasis>&amp;bitlbee</emphasis>. Two users will always be there, <emphasis>you</emphasis> (where "you" is the nickname you are using) and the system user, <emphasis>root</emphasis>.
 </para>
 
@@ -97,5 +97,5 @@
 <ircexample>
 	<ircline nick="you">add 0 r2d2@example.com</ircline>
-	<ircaction nick="r2d2"> has joined <emphasis>#bitlbee</emphasis></ircaction>
+	<ircaction nick="r2d2"> has joined <emphasis>&amp;bitlbee</emphasis></ircaction>
 </ircexample>
 
@@ -122,5 +122,5 @@
 
 <para>
-First of all, a person must be on your contact list for you to chat with them (unless it's a group chat, <emphasis>help groupchats</emphasis> for more). If someone not on your contact list sends you a message, simply add them to the proper account with the <emphasis>add</emphasis> command. Once they are on your list and online, you can chat with them in #bitlbee:
+First of all, a person must be on your contact list for you to chat with them (unless it's a group chat, <emphasis>help groupchats</emphasis> for more). If someone not on your contact list sends you a message, simply add them to the proper account with the <emphasis>add</emphasis> command. Once they are on your list and online, you can chat with them in &amp;bitlbee:
 </para>
 
@@ -131,5 +131,5 @@
 
 <para>
-If you'd rather chat with them in a separate window use the <emphasis>/msg</emphasis> or <emphasis>/query</emphasis> command, just like you would for a private message in IRC.  If you want to have messages automatically come up in private messages rather than in the #bitlbee channel, use the <emphasis>set private</emphasis> command: <emphasis>set private true</emphasis> (<emphasis>set private false</emphasis> to change back).
+If you'd rather chat with them in a separate window use the <emphasis>/msg</emphasis> or <emphasis>/query</emphasis> command, just like you would for a private message in IRC.  If you want to have messages automatically come up in private messages rather than in the &amp;bitlbee channel, use the <emphasis>set private</emphasis> command: <emphasis>set private true</emphasis> (<emphasis>set private false</emphasis> to change back).
 </para>
 