Index: protocols/skype/HACKING
===================================================================
--- protocols/skype/HACKING	(revision e1d6b38fbfa1ba01da45c79a2f1b0951eb5b14bd)
+++ protocols/skype/HACKING	(revision 757e1e0fdd0d80818a480d507e41b5a8e32ceb3e)
@@ -17,10 +17,2 @@
 
 4) irssi
-
-== Get the code from git
-
-To get the code directly from git, you need:
-
-git clone git://vmiklos.hu/bitlbee-skype
-cd bitlbee-skype
-make autogen
Index: protocols/skype/Makefile
===================================================================
--- protocols/skype/Makefile	(revision e1d6b38fbfa1ba01da45c79a2f1b0951eb5b14bd)
+++ protocols/skype/Makefile	(revision 757e1e0fdd0d80818a480d507e41b5a8e32ceb3e)
@@ -4,8 +4,5 @@
 endif
 
-VERSION = 0.9.0
 DATE := $(shell date +%Y-%m-%d)
-# latest stable
-BITLBEE_VERSION = 3.0.1
 INSTALL = install
 ASCIIDOC = yes
@@ -17,46 +14,8 @@
 endif
 
-ifeq ($(BITLBEE),yes)
-LIBS = skype.$(SHARED_EXT)
-else
-LIBS =
-endif
-
-all: $(LIBS) $(MANPAGES)
-
-skype.$(SHARED_EXT): $(_SRCDIR_)skype.c config.mak
-ifeq ($(BITLBEE),yes)
-	$(CC) $(CFLAGS) $(SHARED_FLAGS) -o skype.$(SHARED_EXT) $(_SRCDIR_)skype.c $(LDFLAGS)
-endif
-
-install: all install-doc
-ifeq ($(BITLBEE),yes)
-	$(INSTALL) -d $(DESTDIR)$(plugindir)
-	$(INSTALL) skype.$(SHARED_EXT) $(DESTDIR)$(plugindir)
-endif
-ifeq ($(SKYPE4PY),yes)
-	$(INSTALL) -d $(DESTDIR)$(bindir)
-	$(INSTALL) -d $(DESTDIR)$(sysconfdir)
-	$(INSTALL) skyped.py $(DESTDIR)$(bindir)/skyped
-	perl -p -i -e 's|/usr/local/etc/skyped|$(sysconfdir)|' $(DESTDIR)$(bindir)/skyped
-	$(INSTALL) -m644 skyped.conf.dist $(DESTDIR)$(sysconfdir)/skyped.conf
-	perl -p -i -e 's|\$${prefix}|$(prefix)|' $(DESTDIR)$(sysconfdir)/skyped.conf
-	$(INSTALL) -m644 skyped.cnf $(DESTDIR)$(sysconfdir)
-endif
-
-client: $(_SRCDIR_)client.c
-
-autogen: configure.ac
-	cp $(shell ls /usr/share/automake-*/install-sh | tail -n1) ./
-	autoconf
+all: $(MANPAGES)
 
 clean:
-	rm -f $(LIBS) $(MANPAGES)
-
-distclean: clean
-	rm -f config.log config.mak config.status $(MANPAGES)
-
-autoclean: distclean
-	rm -rf aclocal.m4 autom4te.cache configure install-sh
+	rm -f $(MANPAGES)
 
 # take this from the kernel
@@ -66,18 +25,4 @@
 test: all
 	$(MAKE) -C t/ all
-
-dist:
-	git archive --format=tar --prefix=bitlbee-skype-$(VERSION)/ HEAD | tar xf -
-	mkdir -p bitlbee-skype-$(VERSION)
-	git log --no-merges |git name-rev --tags --stdin > bitlbee-skype-$(VERSION)/Changelog
-	make -C bitlbee-skype-$(VERSION) autogen
-	tar czf bitlbee-skype-$(VERSION).tar.gz bitlbee-skype-$(VERSION)
-	rm -rf bitlbee-skype-$(VERSION)
-
-release:
-	git tag $(VERSION)
-	$(MAKE) dist
-	gpg --comment "See http://vmiklos.hu/gpg/ for info" \
-		-ba bitlbee-skype-$(VERSION).tar.gz
 
 doc: $(MANPAGES)
@@ -92,16 +37,4 @@
 	rm -f $(DESTDIR)$(MANDIR)/man1/skyped.1*
 
-HEADER.html: README Makefile
-	asciidoc -a toc -a numbered -a sectids -o HEADER.html -a icons -a data-uri --attribute iconsdir=./images/icons README
-	sed -i 's|@VERSION@|$(VERSION)|g' HEADER.html
-	sed -i 's|@BITLBEE_VERSION@|$(BITLBEE_VERSION)|g' HEADER.html
-
-Changelog: .git/refs/heads/master
-	git log --no-merges |git name-rev --tags --stdin >Changelog
-
-AUTHORS: .git/refs/heads/master
-	git shortlog -s -n |sed 's/.*\t//'> AUTHORS
-
 %.1: $(_SRCDIR_)%.txt $(_SRCDIR_)asciidoc.conf
-	a2x --asciidoc-opts="-f $(_SRCDIR_)asciidoc.conf" \
-		-a bs_version=$(VERSION) -a bs_date=$(DATE) -f manpage -D . $<
+	a2x --asciidoc-opts="-f $(_SRCDIR_)asciidoc.conf" -a bee_date=$(DATE) -f manpage -D . $<
Index: protocols/skype/README
===================================================================
--- protocols/skype/README	(revision e1d6b38fbfa1ba01da45c79a2f1b0951eb5b14bd)
+++ protocols/skype/README	(revision 757e1e0fdd0d80818a480d507e41b5a8e32ceb3e)
@@ -374,5 +374,5 @@
 
 If something does not work and it's not in the TODO section, then please
-contact me! Please also try the link:HACKING[git version] before reporting a bug, your
+contact me! Please also try the bzr version before reporting a bug, your
 problem may be already fixed there.
 
@@ -393,7 +393,4 @@
 
 == Additional resources
-
-You can reach the Changelog link:Changelog[here], and a gitweb interface
-http://vmiklos.hu/gitweb/?p=bitlbee-skype.git[here].
 
 The Skype API documentation is
Index: protocols/skype/asciidoc.conf
===================================================================
--- protocols/skype/asciidoc.conf	(revision e1d6b38fbfa1ba01da45c79a2f1b0951eb5b14bd)
+++ protocols/skype/asciidoc.conf	(revision 757e1e0fdd0d80818a480d507e41b5a8e32ceb3e)
@@ -5,12 +5,11 @@
 <refentry>
 	<refentryinfo>
-		<date>{bs_date}</date>
+		<date>{bee_date}</date>
 	</refentryinfo>
 	<refmeta>
 		<refentrytitle>{mantitle}</refentrytitle>
 		<manvolnum>{manvolnum}</manvolnum>
-		<refmiscinfo class="source">bitlbee-skype</refmiscinfo>
-		<refmiscinfo class="version">{bs_version}</refmiscinfo>
-		<refmiscinfo class="manual">bitlbee-skype manual</refmiscinfo>
+		<refmiscinfo class="source">BitlBee</refmiscinfo>
+		<refmiscinfo class="manual">BitlBee manual</refmiscinfo>
 	</refmeta>
 	<refnamediv>
Index: protocols/skype/skyped.txt
===================================================================
--- protocols/skype/skyped.txt	(revision e1d6b38fbfa1ba01da45c79a2f1b0951eb5b14bd)
+++ protocols/skype/skyped.txt	(revision 757e1e0fdd0d80818a480d507e41b5a8e32ceb3e)
@@ -12,5 +12,5 @@
 
 Skype supports remote control of the GUI client only via X11 or DBus
-messages. This is hard in care you want remote control. This daemon
+messages. This is hard in case you want remote control. This daemon
 listens on a TCP port and runs on the same machine where the GUI client
 runs. It passes all the input it gets to Skype directly, except for a