Index: debian/po/POTFILES.in
===================================================================
--- debian/po/POTFILES.in	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/POTFILES.in	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,1 @@
+[type: gettext/rfc822deb] bitlbee.templates.master
Index: debian/po/cs.po
===================================================================
--- debian/po/cs.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/cs.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,44 @@
+#
+#    Translators, if you are not familiar with the PO format, gettext
+#    documentation is worth reading, especially sections dedicated to
+#    this format, e.g. by running:
+#         info -n '(gettext)PO Files'
+#         info -n '(gettext)Header Entry'
+#
+#    Some information specific to po-debconf are available at
+#            /usr/share/doc/po-debconf/README-trans
+#         or http://www.debian.org/intl/l10n/po-debconf/README-trans
+#
+#    Developers do not need to manually edit POT or PO files.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2005-02-04 12:31+0100\n"
+"Last-Translator: Miroslav Kure <kurem@debian.cz>\n"
+"Language-Team: Czech <debian-l10n-czech@debian.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=ISO-8859-2\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "Na kterém TCP portu má BitlBee naslouchat pøíchozím spojením?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"BitlBee normálnì naslouchá na bì¾ném IRC portu 6667. Pokud máte spu¹tìný i "
+"reálný IRC daemon, tak to nemusí být nejlep¹í nápad. Vhodná alternativa mù¾e "
+"být 6668. Ponecháte-li pole prázdné, znamená to, ¾e se BitlBee nebude "
+"spou¹tìt automaticky."
Index: debian/po/de.po
===================================================================
--- debian/po/de.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/de.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,45 @@
+#
+#    Translators, if you are not familiar with the PO format, gettext
+#    documentation is worth reading, especially sections dedicated to
+#    this format, e.g. by running:
+#         info -n '(gettext)PO Files'
+#         info -n '(gettext)Header Entry'
+#    Some information specific to po-debconf are available at
+#            /usr/share/doc/po-debconf/README-trans
+#         or http://www.debian.org/intl/l10n/po-debconf/README-trans#
+#    Developers do not need to manually edit POT or PO files.
+# Erik Schanze <mail@erikschanze.de>, 2004.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee_0.90a-2_de\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2004-10-03 14:33+0200\n"
+"Last-Translator: Erik Schanze <mail@erikschanze.de>\n"
+"Language-Team: German <debian-l10n-german@lists.debian.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"X-Generator: KBabel 1.3.1\n"
+"Plural-Forms:  nplurals=2; plural=(n != 1);\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "An welchem TCP-Port soll BitlBee auf Verbindungen warten?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"BitlBee lauscht normalerweise an dem üblichen IRC-Port 6667. Dies ist aber "
+"keine gute Idee, wenn Sie außerdem noch einen richtigen IRC-Dienst "
+"betreiben. Das Port 6668 ist eine gute Alternative. Wenn Sie keinen Wert "
+"eingeben, wird BitlBee nicht automatisch starten."
Index: debian/po/es.po
===================================================================
--- debian/po/es.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/es.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,61 @@
+# bitlbee po-debconf translation to Spanish
+# Copyright (C) 2005 Software in the Public Interest
+# This file is distributed under the same license as the bitlbee package.
+#
+# Changes:
+#  - Initial translation
+#         César Gómez Martín <cesar.gomez@gmail.com>
+#
+#
+#   Traductores, si no conoce el formato PO, merece la pena leer la
+#   documentación de gettext, especialmente las secciones dedicadas a este
+#   formato, por ejemplo ejecutando:
+#          info -n '(gettext)PO Files'
+#          info -n '(gettext)Header Entry'
+# Equipo de traducción al español, por favor, lean antes de traducir
+# los siguientes documentos:
+#
+#  - El proyecto de traducción de Debian al español
+#    http://www.debian.org/intl/spanish/
+#    especialmente las notas de traducción en
+#    http://www.debian.org/intl/spanish/notas
+#
+#  - La guía de traducción de po's de debconf:
+#    /usr/share/doc/po-debconf/README-trans
+#    o http://www.debian.org/intl/l10n/po-debconf/README-trans
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2005-08-24 19:37+0100\n"
+"Last-Translator: César Gómez Martín <cesar.gomez@gmail.com>\n"
+"Language-Team: Debian l10n spanish <debian-l10n-spanish@lists.debian.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=utf-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"X-Poedit-Language: Spanish\n"
+"X-Poedit-Country: SPAIN\n"
+"X-Poedit-SourceCharset: utf-8\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "¿En qué puerto TCP quiere que BitlBee escuche conexiones?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"BitlBee normalmente escucha en el puerto 6667, que se usa también para IRC. "
+"Por esta razón no es muy buena idea poner a BitlBee a escuchar en ese puerto "
+"si también se está ejecutando un demonio real de IRC, en este caso el puerto "
+"6668 puede ser una buena alternativa. Si deja este valor en blanco BitlBee "
+"no se ejecutará automáticamente."
Index: debian/po/fr.po
===================================================================
--- debian/po/fr.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/fr.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,44 @@
+#
+#    Translators, if you are not familiar with the PO format, gettext
+#    documentation is worth reading, especially sections dedicated to
+#    this format, e.g. by running:
+#         info -n '(gettext)PO Files'
+#         info -n '(gettext)Header Entry'
+#
+#    Some information specific to po-debconf are available at
+#            /usr/share/doc/po-debconf/README-trans
+#         or http://www.debian.org/intl/l10n/po-debconf/README-trans
+#
+#    Developers do not need to manually edit POT or PO files.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee (0.80-1)\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2003-08-07 08:45+0100\n"
+"Last-Translator: Christian Perrier <bubulle@debian.org>\n"
+"Language-Team: French <debian-l10n-french@lists.debian.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=iso-8859-15\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "Sur quel port TCP BitlBee doit-il être à l'écoute ?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"BitlBee est usuellement à l'écoute sur le port IRC standard : 6667. Cela "
+"n'est pas forcément un choix adapté si vous utilisez en même temps un vrai "
+"démon IRC. Dans ce cas, choisir 6668 est conseillé. Si vous ne souhaitez pas "
+"lancer BitlBee automatiquement, veuillez laissez ce champs vide."
Index: debian/po/ja.po
===================================================================
--- debian/po/ja.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/ja.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,45 @@
+#
+#    Translators, if you are not familiar with the PO format, gettext
+#    documentation is worth reading, especially sections dedicated to
+#    this format, e.g. by running:
+#         info -n '(gettext)PO Files'
+#         info -n '(gettext)Header Entry'
+#
+#    Some information specific to po-debconf are available at
+#            /usr/share/doc/po-debconf/README-trans
+#         or http://www.debian.org/intl/l10n/po-debconf/README-trans
+#
+#    Developers do not need to manually edit POT or PO files.
+#
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee 0.90a-2\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2004-09-11 13:30+0900\n"
+"Last-Translator: Hideki Yamane <henrich@samba.gr.jp>\n"
+"Language-Team: Japanese <debian-japanese@lists.debian.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=EUC-JP\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "BitlBee ¤Ï¡¢ÀÜÂ³¤Î¤¿¤á¤Ë¤É¤Î TCP ¥Ý¡¼¥È¤ò listen ¤·¤Þ¤¹¤«?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"BitlBee ¤ÏÄÌ¾ï¤Î¾ì¹ç¡¢É¸½à¤Î IRC ¥Ý¡¼¥ÈÈÖ¹æ¤Ç¤¢¤ë 6667 ¤ò listen ¤·¤Þ¤¹¡£Æ±ÍÍ"
+"¤Ë¤·¤Æ¼ÂºÝ¤Î IRC ¥Ç¡¼¥â¥ó¤òÆ°ºî¤µ¤»¤Æ¤¤¤ë¾ì¹ç¡¢¤³¤ì¤Ï¤¢¤Þ¤êÎÉ¤¤¹Í¤¨¤Ç¤ÏÌµ¤¤¤«"
+"¤â¤·¤ì¤Þ¤»¤ó¡£Âå¤ï¤ê¤Ë 6668 ¤ò»È¤¦¤Î¤¬ÎÉ¤¤¤«¤âÃÎ¤ì¤Þ¤»¤ó¡£¤³¤ì¤ò¶õ¤Î¤Þ¤Þ¤Ë¤·"
+"¤Æ¤ª¤±¤Ð¡¢BitlBee ¤Ï¼«Æ°Åª¤Ë¤Ïµ¯Æ°¤Ê¤¯¤Ê¤ê¤Þ¤¹¡£"
Index: debian/po/nl.po
===================================================================
--- debian/po/nl.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/nl.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,44 @@
+#
+#    Translators, if you are not familiar with the PO format, gettext
+#    documentation is worth reading, especially sections dedicated to
+#    this format, e.g. by running:
+#         info -n '(gettext)PO Files'
+#         info -n '(gettext)Header Entry'
+#
+#    Some information specific to po-debconf are available at
+#            /usr/share/doc/po-debconf/README-trans
+#         or http://www.debian.org/intl/l10n/po-debconf/README-trans
+#
+#    Developers do not need to manually edit POT or PO files.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee (0.90a-2)\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2004-09-06 20:16+0200\n"
+"Last-Translator: Wilmer van der Gaast <wilmer@gaast.net>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=ISO-8859-15\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "Op welke TCP poort moet BitlBee draaien?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"Normaal 'luistert' BitlBee op de gebruikelijke IRC poort, 6667. Als je al "
+"een andere IRC daemon draait is dat onmogelijk. Kies dan bijvoorbeeld voor "
+"poort 6668. Als je niet wil dat BitlBee automatisch gestart wordt, vul hier "
+"dan niets in."
Index: debian/po/pt.po
===================================================================
--- debian/po/pt.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/pt.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,36 @@
+# Portuguese translation of bitlbee's debconf messages.
+# This file is distributed under the same license as the bitlbee package.
+# 2006, Marco Ferra <mferra@debianpt.org>
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee 1.0.3-1.1\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2007-01-13 18:53+0100\n"
+"PO-Revision-Date: 2007-01-26 22:34+0000\n"
+"Last-Translator: Marco Ferra <mferra@debianpt.org>\n"
+"Language-Team: Portuguese <traduz@debianpt.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:1001
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "Em que porta TCP deverá o BitlBee escutar por conexões?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:1001
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"O BitlBee normalmente escuta na porta do IRC 6667.  Isto poderá não ser "
+"uma ideia excelente quando está a correr um 'daemon' de IRC ao mesmo tempo. "
+"Nesse caso a porta 6668 poderá ser uma boa alternativa.  Deixar este campo "
+"vazio significa que o BitlBee não irá correr automaticamente."
+
Index: debian/po/pt_BR.po
===================================================================
--- debian/po/pt_BR.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/pt_BR.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,44 @@
+#
+#    Translators, if you are not familiar with the PO format, gettext
+#    documentation is worth reading, especially sections dedicated to
+#    this format, e.g. by running:
+#         info -n '(gettext)PO Files'
+#         info -n '(gettext)Header Entry'
+#
+#    Some information specific to po-debconf are available at
+#            /usr/share/doc/po-debconf/README-trans
+#         or http://www.debian.org/intl/l10n/po-debconf/README-trans
+#
+#    Developers do not need to manually edit POT or PO files.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2005-02-26 16:14-0300\n"
+"Last-Translator: André Luís Lopes <andrelop@debian.org>\n"
+"Language-Team: Debian-BR Project <debian-l10n-portuguese@lists.debian.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=ISO-8859-1\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "Em qual porta TCP o BitlBee deverá ouvir por conexões ?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"O BitlBee normalmente ouve na porta de IRC padrão, 6667. Porém, esta pode "
+"não ser uma boa idéia quando você está rodando um daemon IRC real também. "
+"6689 pode ser uma boa alternativa. Deixar esse valor em branco significa que "
+"o BitlBee não será executado automaticamente."
Index: debian/po/sv.po
===================================================================
--- debian/po/sv.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/sv.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,43 @@
+# Translators, if you are not familiar with the PO format, gettext
+# documentation is worth reading, especially sections dedicated to
+# this format, e.g. by running:
+# info -n '(gettext)PO Files'
+# info -n '(gettext)Header Entry'
+# Some information specific to po-debconf are available at
+# /usr/share/doc/po-debconf/README-trans
+# or http://www.debian.org/intl/l10n/po-debconf/README-trans
+# Developers do not need to manually edit POT or PO files.
+# , fuzzy
+# 
+# 
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee 0.92-2\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2005-10-03 23:18+0200\n"
+"Last-Translator: Daniel Nylander <po@danielnylander.se>\n"
+"Language-Team: Swedish <sv@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=iso-8859-1\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "På vilken TCP-port ska BitlBee lyssna på efter anslutningar?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
+"BitlBee lyssnar normalt på den standardporten för IRC, 6667. Detta kanske "
+"inte är en bra ide om du kör en riktig IRC-daemon på samma system. 6668 kan "
+"vara ett bra alternativ då. Lämnar du detta värde blankt betyder det att "
+"BitlBee inte kommer att startas automatiskt."
Index: debian/po/templates.pot
===================================================================
--- debian/po/templates.pot	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/templates.pot	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,41 @@
+#
+#    Translators, if you are not familiar with the PO format, gettext
+#    documentation is worth reading, especially sections dedicated to
+#    this format, e.g. by running:
+#         info -n '(gettext)PO Files'
+#         info -n '(gettext)Header Entry'
+#
+#    Some information specific to po-debconf are available at
+#            /usr/share/doc/po-debconf/README-trans
+#         or http://www.debian.org/intl/l10n/po-debconf/README-trans
+#
+#    Developers do not need to manually edit POT or PO files.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: PACKAGE VERSION\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=CHARSET\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr ""
Index: debian/po/vi.po
===================================================================
--- debian/po/vi.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
+++ debian/po/vi.po	(revision 793cc254ad2479d95d00266d6cb7ab2bcd158834)
@@ -0,0 +1,32 @@
+# Vietnamese translation for bitlbee.
+# Copyright © 2005 Free Software Foundation, Inc.
+# Clytie Siddall <clytie@riverland.net.au>, 2005.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: bitlbee 0.92-1\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2004-09-25 18:12+0200\n"
+"PO-Revision-Date: 2005-06-12 18:34+0930\n"
+"Last-Translator: Clytie Siddall <clytie@riverland.net.au>\n"
+"Language-Team: Vietnamese <gnomevi-list@lists.sourceforge.net>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=utf-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=1; plural=0\n"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid "On what TCP port should BitlBee listen for connections?"
+msgstr "Trình BitlBee nên lắng nghe sự kết nối trên cổng TCP nào?"
+
+#. Type: string
+#. Description
+#: ../bitlbee.templates.master:4
+msgid ""
+"BitlBee normally listens on the regular IRC port, 6667. This might not be a "
+"very good idea when you're running a real IRC daemon as well. 6668 might be "
+"a good alternative. Leaving this value blank means that BitlBee will not be "
+"run automatically."
+msgstr "Trình BitlBee thường lắng nghe trên cổng IRC bình thường, 6667. Có lẽ nó không phải là một ý kiến tốt nếu bạn cũng có chạy một trình nền (dæmon) IRC thật. Như thế thì, cổng 6668 có thể là một điều thay thế tốt. Nếu bạn bỏ giá trị này rỗng, thì trình BitlBee sẽ không tự động chạy."